"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var blueprint_1 = require("./blueprint");
var resolveValue_1 = require("./utils/resolveValue");
var getKeysAndSymbols_1 = require("./utils/getKeysAndSymbols");
function withHandlers(handlerCreators) {
    return {
        instanceCallbacks: function () {
            var handlers;
            var handlerProps;
            return [
                blueprint_1.propsCallback(function (props) {
                    if (!handlers) {
                        handlers = {};
                        var resolvedHandlers_1 = resolveValue_1.default(handlerCreators, props);
                        getKeysAndSymbols_1.default(resolvedHandlers_1).forEach(function (name) { return handlers[name] = function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            return resolvedHandlers_1[name](handlerProps).apply(void 0, args);
                        }; });
                    }
                    handlerProps = props;
                    return __assign({}, props, handlers);
                }),
            ];
        },
    };
}
exports.withHandlers = withHandlers;
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = withHandlers;

//# sourceMappingURL=withHandlers.js.map
